/***********************************************************************/
/* Projekt : Allgemein                                                 */
/* CPU : Unbestimmt                                                    */
/*                                                                     */
/* Routinen zum verwalten des internen Nachrichen-Systems              */
/*                                                                     */
/*---------------------------------------------------------------------*/
/*                                                                     */
/* Copyright (c) 2007 Martin.S - martinsuniverse.de                    */
/*                                                                     */
/* Dieses Programm oder dieser Teil eines Programms darf verndert     */
/* und weitergegeben werden, solange dies nicht kommerziell geschieht. */
/* Die Nutzung ist nur zum Zweck der Fortbildung und zum  persnlichen */
/* Gebrauch gestattet. Weiterhin muss bei der Weitergabe und           */
/* Verwendung dieser Software der Copyright-Hinweis und die Lizenz-    */
/* bestimmung auch weitergegeben werden und gut erreichbar/abrufbar    */
/* sein.                                                               */
/*                                                                     */
/* Eine Gewhr fr die Funktionstchtigkeit und ein Haftung fr        */
/* Schden, die durch die Benutzung dieser Software entstehen, kann    */
/* nicht von bernommen werden. Es knnen also keine Garantieansprche */
/* geltend gemacht werden.                                             */
/*                                                                     */
/* Der Autor dieses Programms haftet nicht fr Schden an Soft- oder   */
/* Hardware oder Vermgensschden, die durch das Benutzen des          */
/* Programms entstehen, es sei denn diese beruhen auf einem grob       */
/* fahrlssigen oder vorstzlichen Handeln des Autors, seiner          */
/* Erfllungsgehilfen oder seiner gesetzlichen Vertreter.              */
/*                                                                     */
/*---------------------------------------------------------------------*/
/*                                                                     */
/* Historie:                                                           */
/*   01.10.2006  V0.1b  Erste Version                                  */
/*                                                                     */
/***********************************************************************/

#include "msgsys.h"

#define MSGCUEMASK MSGCUESIZE-1

sMSG msgcue[MSGCUESIZE];
char msgcuetop;		// ltester eintrag, muss zu erst verarbeitet werden
char msgcuebot;		// Einfgeposition

//*****************************************************************************
// Funtion : Eintrag der Message-Cueue hinzufgen
// Gltigkeit : global
// Parameter : -
// Rckgabe : Fehlerstatus
//*****************************************************************************
int addmsg(sMSG *newmsg)
{
	asm("fclr i");			// Interrupt sperren

	if (((msgcuebot + 1) & MSGCUEMASK) == msgcuetop)
	{
		asm("fset i");		// Interrupt freigeben
		return OVERFLOW;
	}
	msgcue[msgcuebot] = *newmsg;
	msgcuebot++;
	msgcuebot &= MSGCUEMASK;

	asm("fset i");			// Interrupt freigeben

	return OK;
}

//*****************************************************************************
// Funtion : Eintrag aus der Message-Cueue lesen
// Gltigkeit : global
// Parameter : -
// Rckgabe : Fehlerstatus
//*****************************************************************************
int getmsg(sMSG *readmsg)
{
	if (msgcuetop == msgcuebot)
		return EMPTY;

	*readmsg = msgcue[msgcuetop];
	msgcuetop++;
	msgcuetop &= MSGCUEMASK;

	return OK;
}

//*****************************************************************************
// Funtion : Message-Cueue leeren
// Gltigkeit : global
// Parameter : -
// Rckgabe : -
//*****************************************************************************
void clearmsgcue()
{
	msgcuetop = msgcuebot = 0;
}