/***********************************************************************/
/* Projekt : Allgemein                                                 */
/* CPU : Unbestimmt                                                    */
/*                                                                     */
/* Definitionen zum internen Nachrichen-Systems                        */
/*                                                                     */
/*---------------------------------------------------------------------*/
/*                                                                     */
/* Copyright (c) 2007 Martin.S - martinsuniverse.de                    */
/*                                                                     */
/* Dieses Programm oder dieser Teil eines Programms darf verndert     */
/* und weitergegeben werden, solange dies nicht kommerziell geschieht. */
/* Die Nutzung ist nur zum Zweck der Fortbildung und zum  persnlichen */
/* Gebrauch gestattet. Weiterhin muss bei der Weitergabe und           */
/* Verwendung dieser Software der Copyright-Hinweis und die Lizenz-    */
/* bestimmung auch weitergegeben werden und gut erreichbar/abrufbar    */
/* sein.                                                               */
/*                                                                     */
/* Eine Gewhr fr die Funktionstchtigkeit und ein Haftung fr        */
/* Schden, die durch die Benutzung dieser Software entstehen, kann    */
/* nicht von bernommen werden. Es knnen also keine Garantieansprche */
/* geltend gemacht werden.                                             */
/*                                                                     */
/* Der Autor dieses Programms haftet nicht fr Schden an Soft- oder   */
/* Hardware oder Vermgensschden, die durch das Benutzen des          */
/* Programms entstehen, es sei denn diese beruhen auf einem grob       */
/* fahrlssigen oder vorstzlichen Handeln des Autors, seiner          */
/* Erfllungsgehilfen oder seiner gesetzlichen Vertreter.              */
/*                                                                     */
/*---------------------------------------------------------------------*/
/*                                                                     */
/* Historie:                                                           */
/*   01.10.2006  V0.1b  Erste Version                                  */
/*                                                                     */
/***********************************************************************/

#ifndef msgsys
#define msgsys

#define MSGCUESIZE 32							// nur 2^x Werte sind erlaubt

typedef union
{
	unsigned char b[4];
	unsigned int w[2];
	unsigned long l;
} uLONG;

typedef struct
{
	unsigned int msg;
	uLONG param;
} sMSG;

int addmsg(sMSG *newmsg);
int getmsg(sMSG *readmsg);
void clearmsgcue();

// Allgemein
#define OK				  0
#define KEYPRESS		1
#define TIMER0      10
#define TIMER1      11
#define TIMER2      12
#define TIMER3      13
#define SHUTDOWN		20
#define UARTRX			30

#define UNKNOWN_ERR	-1
#define NOTEQUAL		-2
#define OUTOFRANGE	-100
#define OVERFLOW		-101
#define EMPTY				-102
#define BUSY        -103

#define FLASHCMDSEQ	-200
#define FLASHEREASE -201
#define FLASHPROGRAMM -202

// Flashkarte
#define CARDINSERTED 2000
#define CARDREMOVED  2001

#define NOCARD			-2000
#define TIMEOUT			-2001
#define BLOCKLENGTH	-2002
#define CARDERROR		-2009
// -2010 bis -2255 Karten Response

// Dateisystem
#define READERROR			 			-2300
#define INVALIDBOOTID				-2301
#define NOAKTIVEPARTITION		-2302
#define INVALIDVOLUMEBOOT		-2303
#define INVALIDFILESYSTEM	  -2304
#define FILENOTFOUND				-2305
#define EOF									-2306
#define CACHEOVERFLOW				-2307
#define INVALIDDRIVE        -2308
#define INVALIDFILENAME     -2309
#define FILEINUSE		        -2310
#define FILENOTOPEN         -2311
#define INVALIDFILTER       -2312
#define INVALIDFILESTRUCT   -2313

// MP3 Decoder
#define MP3DATAREQ     3000
#define LOADDATAREQ		 3001

// Anwender definiert
#define USERMSG				 16384
#define USERERROR			-16384

#endif
