;*******************************************************************************
;
; C Compiler for R8C/Tiny, M16C/60,30,20,10
; Copyright(C) 1999(2000-2004). Renesas Technology Corp.
; and Renesas Solutions Corp., All rights reserved.
;
;
; Written by T.Aoyama
;
; sect30.inc     : section definition
; This program is applicable when using the basic I/O library
;
; $Id: sect30.inc,v 1.23.4.6 2004/10/29 14:06:39 simomura Exp $
;
;******************************************************************************

;---------------------------------------------------------------
;
; 	Arrangement of section
;
;---------------------------------------------------------------
; Near RAM data area
;---------------------------------------------------------------
; SBDATA area
	.section	data_SE,DATA
	.org	400H
data_SE_top:

	.section	bss_SE,DATA,ALIGN
bss_SE_top:

	.section	data_SO,DATA
data_SO_top:

	.section	bss_SO,DATA
bss_SO_top:

; near RAM area
	.section	data_NE,DATA,ALIGN
data_NE_top:

	.section	bss_NE,DATA,ALIGN
bss_NE_top:

	.section	data_NO,DATA
data_NO_top:

	.section	bss_NO,DATA
bss_NO_top:

;---------------------------------------------------------------
; Stack area
;---------------------------------------------------------------
	.section	stack,DATA,ALIGN
	.blkb	STACKSIZE
stack_top:

	.blkb	ISTACKSIZE
istack_top:

;---------------------------------------------------------------
; near RAM buffer area
;---------------------------------------------------------------
;	.section	buffer_ram_NE,DATA
;	.org 			0600H
;	.section	buffer_ram_NO,DATA
;-----------------------------------	
;	.section	buffer_ram_NEI,ROMDATA
;	.section	buffer_ram_NOI,ROMDATA

;---------------------------------------------------------------
;	heap section
;---------------------------------------------------------------
	.section	heap,DATA
heap_top:
	.blkb	HEAPSIZE

;---------------------------------------------------------------
; Near ROM data area
;---------------------------------------------------------------
	.section	rom_NE,ROMDATA
	.org		0e800H		
rom_NE_top:

	.section	rom_NO,ROMDATA
rom_NO_top:

;---------------------------------------------------------------
; Initial data of 'data' section
;---------------------------------------------------------------
	.section	data_SEI,ROMDATA,ALIGN
data_SEI_top:

	.section	data_SOI,ROMDATA
data_SOI_top:

	.section	data_NEI,ROMDATA,ALIGN
data_NEI_top:
 
	.section	data_NOI,ROMDATA
data_NOI_top:

;---------------------------------------------------------------
; Switch Table Section
;---------------------------------------------------------------
	.section        switch_table,ROMDATA
switch_table_top:

;---------------------------------------------------------------
; code area
;---------------------------------------------------------------

	.section	program,CODE,ALIGN

	.section	interrupt,CODE,ALIGN

.if	__MVT__ == 0 
;---------------------------------------------------------------
; variable vector section
;---------------------------------------------------------------
	.section	vector,ROMDATA	; variable vector table
	.org	VECTOR_ADR 

	.glb _timerb_isr
	.glb _usbrx_isr
	.glb _usbtx_isr
	.glb _canrx_isr
	.glb _cantx_isr
	.glb _canerr_isr

	.lword	dummy_int		; vector 0
	.lword	dummy_int		; vector 1
	.lword	dummy_int		; vector 2
	.lword	dummy_int		; vector 3
	.lword	_canrx_isr	; vector 4 - CAN successful receive
	.lword	_cantx_isr	; vector 5 - CAN successful transmit
	.lword	dummy_int		; vector 6
	.lword	dummy_int		; vector 7
	.lword	dummy_int		; vector 8
	.lword	dummy_int		; vector 9
	.lword	dummy_int		; vector 10
	.lword	dummy_int		; vector 11
	.lword	dummy_int		; vector 12
	.lword	dummy_int		; vector 13
	.lword	dummy_int		; vector 14
	.lword	dummy_int		; vector 15
	.lword	dummy_int		; vector 16
.if	_KD_	
	.lword	_usbtx_isr	; vector 17 - UART0 transmit
	.lword	_usbrx_isr	; vector 18 - UART0 receive
	.lword	dummy_int		; vector 19 - UART1 transmit
	.lword	dummy_int		; vector 20 - UART1 receive
.else
	.lword	dummy_int		; vector 17 - UART0 transmit
	.lword	dummy_int		; vector 18 - UART0 receive
	.lword	_usbtx_isr	; vector 19 - UART1 transmit
	.lword	_usbrx_isr	; vector 20 - UART1 receive
.endif
	.lword	dummy_int		; vector 21
	.lword	dummy_int		; vector 22 - Zeitgeber A
	.lword	dummy_int		; vector 23
	.lword	_timerb_isr	; vector 24 - Zeitgeber B
	.lword	dummy_int		; vector 25
	.lword	dummy_int		; vector 26
	.lword	dummy_int		; vector 27
	.lword	dummy_int		; vector 28
	.lword	dummy_int		; vector 29
	.lword	dummy_int		; vector 30
	.lword	dummy_int		; vector 31
	.lword	dummy_int		; vector 32 
	.lword	dummy_int		; vector 33 
	.lword	dummy_int		; vector 34 
	.lword	dummy_int		; vector 35 
	.lword	dummy_int		; vector 36 
	.lword	dummy_int		; vector 37 
	.lword	dummy_int		; vector 38 
	.lword	dummy_int		; vector 39 
	.lword	dummy_int		; vector 40 
	.lword	dummy_int		; vector 41 
	.lword	dummy_int		; vector 42 
	.lword	dummy_int		; vector 43 
	.lword  dummy_int		; vector 44 
	.lword	dummy_int		; vector 45 
	.lword	dummy_int		; vector 46 
	.lword	dummy_int 	; vector 47 
	.lword	dummy_int 	; vector 48
	.lword	dummy_int 	; vector 49
	.lword	dummy_int 	; vector 50
	.lword	dummy_int 	; vector 51
	.lword	dummy_int 	; vector 52
	.lword	dummy_int 	; vector 53
	.lword	dummy_int 	; vector 54
	.lword	dummy_int 	; vector 55
	.lword	dummy_int 	; vector 56
	.lword	dummy_int 	; vector 57
	.lword	dummy_int 	; vector 58
	.lword	dummy_int 	; vector 59
	.lword	dummy_int 	; vector 60 
	.lword	dummy_int 	; vector 61
	.lword	dummy_int 	; vector 62
	.lword	dummy_int 	; vector 63

.else ; __MVT__
	.section	__NC_rvector,ROMDATA
	.org		VECTOR_ADR
.endif

;===============================================================
; fixed vector section
;---------------------------------------------------------------
	.section	fvector,ROMDATA		; fixed vector table
;	.org	0ffdcH
;UDI:
;	.lword	dummy_int
;OVER_FLOW:
;	.lword	dummy_int
;BRKI:
;	.lword	dummy_int
;ADDRESS_MATCH:
;	.lword	dummy_int
;SINGLE_STEP:
;	.lword	dummy_int
;WDT:
;	.lword	dummy_int
;RESERVED:
;	.lword	dummy_int
;RESERVED:
;	.lword	dummy_int
	.org	0fffcH
RESET:
	.lword	start
	;
	; ID code check function
	; .id "CodeChk"
	;
	; option function select register
	;
	.ofsreg	0FFH

